***

title: Reverse a card sale or a pre-authorization
icon: step-backward
published: true
intro: Cancel a card sale or a pre-authorization that's in an open batch.
---------------------

For clean Markdown of any page, append .md to the page URL. For a complete documentation index, see https://docs.payroc.com/full-stack-guides/take-payments/payroc-cloud/extend-your-solution/llms.txt. For full documentation content, see https://docs.payroc.com/full-stack-guides/take-payments/payroc-cloud/extend-your-solution/llms-full.txt.

If a customer requests a refund and the payment is still in an open batch, the merchant can use their POS to look up the card payment and cancel the transaction.
To find the `paymentId` of the card payment that the merchant wants to reverse, they can retrieve a list of all the card payments that meet the search criteria that the merchant provides. They can then find the transaction that they want in the list of returned results.

<Note>
  **Note:** If the merchant runs a referenced refund on a bank transfer payment that is in an open batch, our gateway automatically reverses the payment.
</Note>

## Integration steps

**Step 1.** (Optional) List card payments.\
**Step 2.** Reverse a card payment.

## Before you begin

### Bearer tokens

Use our Identity Service to generate a Bearer token to include in the header of your requests. To generate your Bearer token, complete the following steps:

1. Include your API key in the x-api-key parameter in the header of a POST request.
2. Send your request to [https://identity.payroc.com/authorize](https://identity.payroc.com/authorize).

<Note>
  **Note:** You need to generate a new Bearer token before the previous Bearer token expires.
</Note>

#### Example request

```bash
curl --location --request POST  'https://identity.payroc.com/authorize' --header 'x-api-key: <api key>'
```

#### Example response

If your request is successful, we return a response that contains your Bearer token, information about its scope, and when it expires.

```json
{
  "access_token": "eyJhbGc....adQssw5c",
  "expires_in": 3600,
  "scope": "service_a service_b",
  "token_type": "Bearer"
}
```

### Headers

To create the header of each POST request, you must include the following parameters:

* **Content-Type:** Include application/json as the value for this parameter.
* **Authorization:** Include your Bearer token in this parameter.
* **Idempotency-Key:** Include a UUID v4 to make the request idempotent.

```bash
curl
-H "Content-Type: application/json"
-H "Authorization: <Bearer token>"
-H "Idempotency-Key: <UUID v4>"
```

### Errors

If your request is unsuccessful, we return an error. For more information about errors, see [Errors](/api/errors).

## Step 1 (Optional) List payments

To retrieve a list of card payments, send a GET request to our Payments endpoint.

Use our filters to narrow down the search results.

| Endpoint   | Prefix     | URL                                                                              |
| :--------- | :--------- | :------------------------------------------------------------------------------- |
| Test       | `api.uat.` | [https://api.uat.payroc.com/v1/payments](https://api.uat.payroc.com/v1/payments) |
| Production | `api.`     | [https://api.payroc.com/v1/payments](https://api.payroc.com/v1/payments)         |

### Request parameters

To create the body of your request, use the following parameters:

<EndpointSchemaSnippet endpoint="GET /payments" selector="request.query" />

### Example request

<EndpointRequestSnippet endpoint="GET /payments" />

### Response fields

If your request is successful, we retrieve the card payment information and return a response. The response contains the following fields:

<EndpointSchemaSnippet endpoint="GET /payments" selector="response.body" />

### Example response

<EndpointResponseSnippet endpoint="GET /payments" />

## Step 2. Reverse a payment

To reverse a card payment, send a POST request to our Reverse endpoint.

If the merchant wants to reverse only part of the transaction, send the amount that they want to reverse in the amount parameter.

| Endpoint   | Prefix     | URL                                                                                                                        |
| :--------- | :--------- | :------------------------------------------------------------------------------------------------------------------------- |
| Test       | `api.uat.` | [https://api.uat.payroc.com/v1/payments/\{paymentId}/reverse](https://api.uat.payroc.com/v1/payments/\{paymentId}/reverse) |
| Production | `api.`     | [https://api.payroc.com/v1/payments/\{paymentId}/reverse](https://api.payroc.com/v1/payments/\{paymentId}/reverse)         |

### Request parameters

To create the body of your request, use the following parameters:

<EndpointSchemaSnippet endpoint="POST /payments/{paymentId}/reverse" selector="request.body" />

### Example request

<EndpointRequestSnippet endpoint="POST /payments/{paymentId}/reverse" />

### Response fields

If your request is successful, we reverse the card payment and return a response. The response contains the following fields:

<EndpointSchemaSnippet endpoint="POST /payments/{paymentId}/reverse" selector="response.body" />

### Example response

<EndpointResponseSnippet endpoint="POST /payments/{paymentId}/reverse" />

## Test cases

Before you run test cases, read the [Payments](/test/test-your-integration/payments) page in Test Your Integration.

### Reverse a card payment

Send a POST request to the following endpoint:

POST [https://api.uat.payroc.com/v1/payments/\{paymentId}/reverse](https://api.uat.payroc.com/v1/payments/\{paymentId}/reverse)

<Note>
  **Note:** The previous payment must be in the open batch and not settled.
</Note>

**Example response**

```json
{
	"paymentId": "LRJ1QWEFRN",
	"processingTerminalId": "3204001",
	"operator": "notRequired",
	"order": {
		"orderId": "Test_007",
		"dateTime": "2023-05-25T10:39:10+01:00",
		"amount": 4000,
		"currency": "USD",
		"standingInstructions": {
			"sequence": "subsequent",
			"processingModel": "recurring"
		}
	},
	"card": {
		"type": "Visa Credit",
		"entryMethod": "keyed",
		"cardNumber": "444433******1111",
		"expiryDate": "1226",
		"secureToken": {
			"secureTokenId": "MREF_1a93f3a6-9029-419f-9e87-3e2db6f0ae85uA",
			"customerName": "",
			"token": "2967538502417872",
			"status": "cvv_validated",
			"link": {
				"rel": "self",
				"method": "GET",
				"href": "https://api.uat.payroc.com/v1/processing-terminals/3204001/secure-tokens/MREF_1a93f3a6-9029-419f-9e87-3e2db6f0ae85uA"
			}
		},
		"securityChecks": {
			"cvvResult": "M",
			"avsResult": "Y"
		}
	},
	"transactionResult": {
		"type": "sale",
		"status": "reversal",
		"approvalCode": "OK14866",
		"authorizedAmount": 4000,
		"currency": "USD",
		"responseCode": "A",
		"responseMessage": "OK14866",
		"cardSchemeReferenceId": "zz67WbxsEwMkvbSNcxz9"
	}
}

```